﻿/*==========================================================================================================================
(c) Dmitriy N. Sakharov
Обработка нумерованных списков v.1.1

Скрипт трансформирует обычный нумерованный текст в цифровые и буквенные списки, добавляя табуляторы или символ IndentToHere. 
Работа проводится с цифрами (арабскими и римскими) и буквами с точкой или скобкой.
Обработка проводится как по выделенному тексту, так и по всему тексту в story (если выделен текстовый фрейм или курсор стоит в story).
Можно обрабатывать текст только заданного стиля.
Обработанным спискам можно присваивать выбранный стиль.

Вопросы и замечания по работе скрипта направляйте на sakhar@mail.ru

ИЗМЕНЕНИЯ В ВЕРСИИ 1.1
1. Улучшен алгоритм добавления спецсимволов. Теперь работает намного быстрее.
2. Добавлена возможность отключения сообщения о завершении работы скрипта.
3. Исправлена ошибка работы скрипта при некорректно заданных переменных по умолчанию.
===========================================================================================================================*/	

var myResult, mySearch, myIndex;
var mySelectIndexParagraphStyle1 = 0;
var mySelectIndexParagraphStyle2 = 0;
//Переменные по умолчанию
var myParagraphStyleNameSelect = "_osn_text";
var mySpisStyleSelect = "_spisok";
var myAllParagraphStyle = true;
var myAppStyle = false;
var myEnd = true;
with(app){
	if(app.documents.length==0){
		alert("Нет открытых документов!");
		exit();
	}
	if(selection.length==0){
		alert("Ничего не выделено!");
		exit();
	}
	if (selection[0].constructor.name == "InsertionPoint" || selection[0].constructor.name =="TextFrame") {
		mySelect=activeDocument.selection[0].parentStory;
		var myState=confirm("Внимание!!! Не выделен текст!\nОбработка будет проводится по всему тексту в story.");
		if (!myState) {exit();}
	}
	else {mySelect=activeDocument.selection[0];}		
	// Создаем список стилей в публикации
	var myParagraphStyleName = new Array();
	var mySelectIndexParagraphStyle = 0;
	for (myCounter = 0; myCounter < activeDocument.paragraphStyles.length; myCounter++) {
		myParagraphStyleName[myCounter] = activeDocument.paragraphStyles.item(myCounter).name;
		if (myParagraphStyleName[myCounter] == myParagraphStyleNameSelect) {
			mySelectIndexParagraphStyle1 = myCounter;
		}
		if (myParagraphStyleName[myCounter] == mySpisStyleSelect) {
			mySelectIndexParagraphStyle2 = myCounter;
		}
	}
	// Создаем диалог
	var myDialog = dialogs.add({name:"Обработка нумерованных списков v1.1"});
	// Подготовка
	with (myDialog.dialogColumns.add()) {
		with (dialogRows.add().borderPanels.add().dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Обрабатывать абзацы стиля:"});
				var myDialogParagraphStyle = dropdowns.add({stringList:myParagraphStyleName, selectedIndex:mySelectIndexParagraphStyle1});
				staticTexts.add({staticLabel:" или Все"});
				var myDialogAllParagraphStyle = checkboxControls.add({});
				myDialogAllParagraphStyle.checkedState = myAllParagraphStyle;
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Нумерация:"});
				var myRadioButtonGroup1 = radiobuttonGroups.add();
				with(myRadioButtonGroup1){
					var myArabRadioButton = radiobuttonControls.add({staticLabel:"Арабские цифры", checkedState:true});
					var myRimRadioButton = radiobuttonControls.add({staticLabel:"Римские цифры"});
					var myLetRadioButton = radiobuttonControls.add({staticLabel:"Буквы"});
				}
				staticTexts.add({staticLabel:"         Структура:"});
				var myRadioButtonGroup2 = radiobuttonGroups.add();
				with(myRadioButtonGroup2){
					var myIndentRadioButton = radiobuttonControls.add({staticLabel:"IndentToHere", checkedState:true});
					var myTabRadioButton = radiobuttonControls.add({staticLabel:"Табулятор"});
					var myDoubleRadioButton = radiobuttonControls.add({staticLabel:"Два табулятора"});
				}
			}			
			with (dialogRows.add()) {
				var myDialogAppStyle = checkboxControls.add({});
				myDialogAppStyle.checkedState = myAppStyle;
				staticTexts.add({staticLabel:"Присвоить обработанным спискам стиль: "});
				var myDialogSpisStyle = dropdowns.add({stringList:myParagraphStyleName, selectedIndex:mySelectIndexParagraphStyle2});
			}			
			with (dialogRows.add()) {
				var myDialogEnd = checkboxControls.add({});
				myDialogEnd.checkedState = myEnd;
				staticTexts.add({staticLabel:"Показывать сообщение о завершении работы скрипта"});
			}		
		}
		with (dialogRows.add()) {			
			dialogColumns.add().staticTexts.add({staticLabel:"(с) Dmitriy N. Sakharov    sakhar@mail.ru"});
		}
	}
	// Показываем
	var myRes = myDialog.show();
	if (!myRes) {
		myDialog.destroy();
		exit();
	}	
	myParagraphStyle = activeDocument.paragraphStyles.item(myDialogParagraphStyle.selectedIndex);
	myAllParagraphStyle = myDialogAllParagraphStyle.checkedState;
	myAppStyle = myDialogAppStyle.checkedState;
	mySpisStyle = activeDocument.paragraphStyles.item(myDialogSpisStyle.selectedIndex);
	//Анализ структуры списка
	if(myRadioButtonGroup1.selectedButton == 0){
		mySearch=new RegExp ("(\^\\d+[.)]\\ )", "gm");
	}
	else if(myRadioButtonGroup1.selectedButton == 1){
		mySearch=new RegExp ("(\^[IVXL]+\\. )", "gm");
	}
	else{
		mySearch=new RegExp ("(\^[a-zA-Zа-яА-Я]\\) )", "gm");
	}
	//Обработка
	var mytime0 = new Date(); // Запуск таймера
	try{
		i = mySelect.contents.match(mySearch).length;
	}
	catch (myError){
		alert("В текущем выделении обрабатывать нечего!");
		exit();
	}
	switch(myRadioButtonGroup2.selectedButton){
		//IndentToHere
		case 0:
			while(i > 0) {
  				myResult = mySearch.exec(mySelect.contents);  		
  				myIndex = myResult.index + myResult[0].length;
  				if (myAllParagraphStyle || mySelect.characters[myIndex].appliedParagraphStyle == myParagraphStyle){					
					mySelect.insertionPoints[myIndex].contents = 1397319796;
					if (myAppStyle == true){
						mySelect.characters[myIndex].appliedParagraphStyle = mySpisStyle;							
					}
				}
				--i;				
			}
			break;
		//Табулятор
		case 1:
			while(i > 0) {
  				myResult = mySearch.exec(mySelect.contents);  		
  				myIndex = myResult.index + myResult[0].length;
				if (myAllParagraphStyle || mySelect.characters[myIndex].appliedParagraphStyle == myParagraphStyle){
					mySelect.characters[myIndex-1].contents = "\t";
					if (myAppStyle == true){
						mySelect.characters[myIndex].appliedParagraphStyle = mySpisStyle;							
					}
				}				
				--i;
			}
			break;				
		//Два табулятора
		default:
			while(i > 0) {
  				myResult = mySearch.exec(mySelect.contents);  		
  				myIndex = myResult.index + myResult[0].length;  				
				if (myAllParagraphStyle || mySelect.characters[myIndex].appliedParagraphStyle == myParagraphStyle){
					mySelect.characters[myIndex-1].contents = "\t";
					mySelect.insertionPoints[myResult.index].contents = "\t";
					if (myAppStyle == true){
						mySelect.characters[myIndex].appliedParagraphStyle = mySpisStyle;							
					}
				}
				--i;	
			}
		break;
		}
	if (myDialogEnd == true){
		// Время работы скрипта
		var mytime1 = new Date(); 
	    var mymin = Number(mytime1.getMinutes() - mytime0.getMinutes()); 
		var mysec = Number(mytime1.getSeconds() - mytime0.getSeconds()); 
		alert("Обработка завершена!\n" + "Время работы: " + mymin + " мин " + mysec + " с" + "\n\n(с) Dmitriy N. Sakharov \n sakhar@mail.ru");
	}	
}